package apims

import (
	"database/sql"

	"git.sr.ht/~mil/mobroute/util/utilcache"
	"git.sr.ht/~mil/mobroute/util/utilfuncs"
	"github.com/mattn/go-sqlite3"
)

func registerCustomSQLiteDriver(customDriverName string) {
	if !utilfuncs.StringInArray(sql.Drivers(), customDriverName) {
		sql.Register(customDriverName, &sqlite3.SQLiteDriver{
			ConnectHook: func(conn *sqlite3.SQLiteConn) error {
				dbFuncs := map[string]any{
					"ext_haversinedistkm":        dbfunc_ext_haversinedistkm,
					"ext_timezonetoutcdeltasecs": dbfunc_ext_timezonetoutcdeltasecs,
				}
				for dbfuncname, cb := range dbFuncs {
					if err := conn.RegisterFunc(dbfuncname, cb, true); err != nil {
						return err
					}
				}
				return nil
			},
		})
	}
}

func dbPath(mobsqlConfigSetPath string) string {
	if mobsqlConfigSetPath == "" {
		return utilcache.CacheDir("") + "/sqlite.db"
	} else {
		return mobsqlConfigSetPath
	}
}
