package apims

import (
	"git.sr.ht/~mil/mobroute/util/utilfuncs"
	"git.sr.ht/~mil/mobroute/util/utillog"
	"strconv"
)

func dbfunc_ext_haversinedistkm(aLat, aLon, bLat, bLon float64) float64 {
	return utilfuncs.DistHaversine(
		utilfuncs.Coord{Lat: aLat, Lon: aLon},
		utilfuncs.Coord{Lat: bLat, Lon: bLon},
	)
}

func dbfunc_ext_timezonetoutcdeltasecs(yyyymmdd uint, timezone string) string {
	if deltaSeconds, err := utilfuncs.TimezoneToUTCDeltaSecs(yyyymmdd, timezone); err != nil {
		utillog.Infof("Error converting timezone %s for day %d to UTC delta seconds: %v", timezone, yyyymmdd, err)
		return ""
	} else {
		return strconv.Itoa(deltaSeconds)
	}
}
