package formatterlegs

import "time"

func ptr[T any](a T) *T {
	return &a
}

func coalesce[T any](a, b *T) *T {
	if a != nil {
		return a
	} else {
		return b
	}
}

// walkCalcSecs calculates the seconds it takes to walk the given distKm given
func walkCalcSecs(distKm, walkspeedKmHr float64) uint {
	return uint(distKm / walkspeedKmHr * 60 * 60)
}

func createTime(yyyymmdd uint, timezoneUTCSeconds, daySeconds int) time.Time {
	var (
		year     = int(yyyymmdd / 10000)
		month    = time.Month((yyyymmdd / 100) % 100)
		day      = int(yyyymmdd % 100)
		zone     = time.FixedZone("user_zone", timezoneUTCSeconds)
		midnight = time.Date(year, month, day, 0, 0, 0, 0, zone)
	)
	return midnight.Add(time.Duration(daySeconds-timezoneUTCSeconds) * time.Second)
}
