package formatterlegs

import (
	"fmt"
	"time"

	"git.sr.ht/~mil/mobroute/util/utilfuncs"
)

func FormatLegWalk(
	coordFrom, coordTo utilfuncs.Coord,
	labelFrom, labelTo string,
	beginWalkAtTime time.Time,
	walkspeedKmHr float64,
) *RouteLeg {
	var (
		walkDistKm = utilfuncs.DistHaversine(coordFrom, coordTo)
		walkSecs   = walkCalcSecs(walkDistKm, walkspeedKmHr)
	)

	return &RouteLeg{
		LegType:       "walk",
		LegDuration:   utilfuncs.DurationFormatSecs(walkSecs),
		LegFromCoords: fmt.Sprintf("%0.04f, %0.04f", coordFrom.Lat, coordFrom.Lon),
		LegToCoords:   fmt.Sprintf("%0.04f, %0.04f", coordTo.Lat, coordTo.Lon),
		LegBeginTime:  beginWalkAtTime,
		LegEndTime:    beginWalkAtTime.Add(time.Duration(walkSecs) * time.Second),
		WalkFrom:      &labelFrom,
		WalkTo:        &labelTo,
		WalkDistKm:    &walkDistKm,
	}
}
