package formatterlegs

import "time"

type StopDetails struct {
	Time   time.Time `json:"stop_time"`
	Name   string    `json:"stop_name"`
	Coords string    `json:"stop_coords"`
	ConnID string    `json:"stop_conn_id"`
}

type RouteLeg struct {
	LegType       string    `json:"leg_type"` // transfer, walk, or trip
	LegBeginTime  time.Time `json:"leg_begin_time,omitempty"`
	LegEndTime    time.Time `json:"leg_end_time,omitempty"`
	LegDuration   string    `json:"leg_duration"`
	LegFromCoords string    `json:"leg_from_coords"`
	LegToCoords   string    `json:"leg_to_coords"`

	// When LegType == "trip" will be present
	TripRoute         *string         `json:"trip_route,omitempty"`
	TripRouteHeadsign *string         `json:"trip_route_headsign,omitempty"`
	TripFrom          *string         `json:"trip_from,omitempty"`
	TripFromSIDU      *string         `json:"-"`
	TripToSIDU        *string         `json:"-"`
	TripTo            *string         `json:"trip_to,omitempty"`
	TripStops         *[]*StopDetails `json:"trip_stops,omitempty"`
	TripSource        *int            `json:"trip_source,omitempty"`
	TripAgencyID      *string         `json:"trip_agency_id,omitempty"`
	//TripID            *string                  `json:"trip_id,omitempty"`
	//TripConnections   *[]*db.ConnectionVerbose `json:"trip_connections,omitempty"`

	// When LegType == "walk" wil be present
	TransferFrom     *string `json:"transfer_from,omitempty"`
	TransferTo       *string `json:"transfer_to,omitempty"`
	TransferDdwell   *string `json:"transfer_ddwell,omitempty"`
	TransferDactive  *string `json:"transfer_dactive,omitempty"`
	TransferCategory *string `json:"transfer_category,omitempty"`
	TransferSources  *[]int  `json:"transfer_sources,omitempty"`

	// When LegType == "transfer" will be present
	WalkTo     *string  `json:"walk_to,omitempty"`
	WalkFrom   *string  `json:"walk_from,omitempty"`
	WalkDistKm *float64 `json:"walk_dist_km,omitempty"`
}
