package apiroute

import (
	"time"
)

type Timer struct {
	lastTime time.Time
}

func (t *Timer) Snapshot() string {
	now := time.Now()
	delta := now.Sub(t.lastTime)
	t.lastTime = now
	return delta.String()
}

func ptr[T any](a T) *T {
	return &a
}

func coalesce[T any](a, b *T) *T {
	if a != nil {
		return a
	} else {
		return b
	}
}
