package apiroute

import (
	"git.sr.ht/~mil/mobroute/api/apims"
	"git.sr.ht/~mil/mobroute/api/apiroute/diagnosticst"
	"git.sr.ht/~mil/mobroute/api/apiroute/formattergeojson"
	"git.sr.ht/~mil/mobroute/api/apiroute/formatterlegs"
	"git.sr.ht/~mil/mobroute/dbt"
	"git.sr.ht/~mil/mobroute/util/utilfuncs"
	"time"
)

type RouteParams struct {
	MSParams *apims.MSParams `yaml:"load" json:"load"`

	From               *utilfuncs.Coord `yaml:"from" json:"from"`
	To                 *utilfuncs.Coord `yaml:"to" json:"to"`
	Time               *time.Time       `yaml:"time" json:"time"` // Time of departure; if nil, uses now
	MaxWalkSeconds     *uint            `yaml:"max_walk_seconds" json:"max_walk_seconds"`
	MaxTripSeconds     *uint            `yaml:"max_trip_seconds" json:"max_trip_seconds"`
	MaxTransferSeconds *uint            `yaml:"max_transfer_seconds" json:"max_transfer_seconds"`
	MinTransferSeconds *uint            `yaml:"min_transfer_seconds" json:"min_transfer_seconds"`
	MaxNTransfers      *uint            `yaml:"max_n_transfers" json:"max_n_transfers"`
	WalkspeedKmHr      *float64         `yaml:"walkspeed_km_hr" json:"walkspeed_km_hr"`
	TransferCategories *[]string        `yaml:"transfer_categories" json:"transfer_categories"`

	OutputFormats *[]string `yaml:"output_formats" json:"output_formats"`
}

type RouteResponse struct {
	RouteLegs   *[]formatterlegs.RouteLeg          `json:"legs,omitempty"`
	GeoJSON     *[]formattergeojson.GeoJSONFeature `json:"geojson,omitempty"`
	MapURL      *string                            `json:"mapurl,omitempty"`
	Request     *RouteParams                       `json:"request,omitempty"`
	Diagnostics *diagnosticst.Diagnostics          `json:"diagnostics,omitempty"`
	Connections *[]dbt.ConnectionVerbose           `json:"connections,omitempty"`
}
