package apiroute_test

import (
	"fmt"
	"git.sr.ht/~mil/mobroute/api/apims"
	"git.sr.ht/~mil/mobroute/api/apiroute"
	"git.sr.ht/~mil/mobroute/testhelper"
	"git.sr.ht/~mil/mobsql"
	"os"
	"testing"
)

func Test_ApiRouteYMLGTFS(t *testing.T) {
	if mockMobilityDBCSV, gtfsZips, err := testhelper.PrepareMockMobilityDBMockFromGTFSYMLs(
		map[int]string{42: "../../testhelper/mockgtfs/gtfs_sample_0.yml"},
	); err != nil {
		t.Fatalf("Failed to prepare mock: %v", err)
	} else if sqliteDB, err := os.CreateTemp("", "mobroute_test_sqlite_*.db"); err != nil {
		t.Fatalf("Failed to create mock SQLite DB: %v", err)
	} else if response, err := apiroute.Route(&apiroute.RouteParams{
		MSParams: &apims.MSParams{
			LoadConfig: &mobsql.RuntimeConfig{
				MobilityDBCatalogCSVURI: fmt.Sprintf("file://%s", mockMobilityDBCSV),
				SQLiteDBPath:            sqliteDB.Name(),
				AllowFileURIs:           true,
				LogInfo:                 true,
				LogWarn:                 true,
				LogDebug:                true,
			},
			LoadFilter: &mobsql.SourcesetFilter{},
		},
	}); err != nil {
		//t.Fatalf("Error: %v", err)
	} else {
		_ = response
		for _, z := range gtfsZips {
			os.Remove(z)
		}
		os.Remove(mockMobilityDBCSV)
	}
}
