with input_coord as (select ? as lat, ? as lon)
select
	distinct vsp.source || '_' || vsp.parent_station as stop_sidu,
	s.stop_name,
	iif(
		ext_haversinedistkm(s.stop_lat, s.stop_lon, input_coord.lat, input_coord.lon) > ?,
		null,
		ext_haversinedistkm(s.stop_lat, s.stop_lon, input_coord.lat, input_coord.lon)
	) as dist_km
from
  input_coord
  join stops s on s.source in (%s)
  join _vstopparent vsp on vsp.parent_station = s.stop_id
  order by dist_km asc
