package dbt

// CalToService maps a given service_date to a service_id for a source.
// This is a direct representiation of a row from _vcaltoservice.
type CalToService struct {
	Source      int    `db:"source"`
	ServiceDate int    `db:"service_date"`
	ServiceID   string `db:"service_id"`
}

// StopToParent maps a given stop_id to its "ultimate" parent for a source.
// This is a direct representation of a row from _vstopparent.
type StopToParent struct {
	Source        int    `db:"source"`
	StopID        string `db:"stop_id"`
	ParentStation string `db:"parent_station"`
}
