package utilfuncs

import "math"

type Coord struct {
	Lat float64 `yaml:"lat" json:"lat"`
	Lon float64 `yaml:"lon" json:"lon"`
}

func DistHaversine(a, b Coord) float64 {
	phiA := (90.0 - a.Lat) * math.Pi / 180.0
	phiB := (90.0 - b.Lat) * math.Pi / 180.0
	thetaA := a.Lon * math.Pi / 180.0
	thetaB := b.Lon * math.Pi / 180.0
	c := math.Sin(phiA)*math.Sin(phiB)*math.Cos(thetaA-thetaB) + math.Cos(phiA)*math.Cos(phiB)
	arc := math.Acos(c)
	scaleKm := 6371.0
	return arc * scaleKm
}
